diff --git a/pom.xml b/pom.xml
index 0bcf6a9..3b0fe2e 100644
--- a/pom.xml
+++ b/pom.xml
@@ -1,158 +1,158 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd">
-	<modelVersion>4.0.0</modelVersion>
-	<parent>
-		<groupId>org.jenkins-ci.plugins</groupId>
-		<artifactId>plugin</artifactId>
-		<version>1.451</version>
-		<!-- <version>1.460</version> version caused JENKINS-13518 -->
-	</parent>
+    <modelVersion>4.0.0</modelVersion>
+    <parent>
+        <groupId>org.jenkins-ci.plugins</groupId>
+        <artifactId>plugin</artifactId>
+        <version>1.451</version>
+        <!-- <version>1.460</version> version caused JENKINS-13518 -->
+    </parent>
 
-	<artifactId>scriptler</artifactId>
-	<name>Scriptler</name>
-	<version>2.6-SNAPSHOT</version>
-	<packaging>hpi</packaging>
-	<description>Scriptler allows you to store/edit/execute groovy scripts on any of the slaves/nodes... no need to copy paste groovy code anymore. Beside administer  your scripts, Scritpler also provides a way to share scripts between users via hosted script catalogs on the internet.</description>
-	<url>http://wiki.jenkins-ci.org/display/JENKINS/Scriptler+Plugin</url>
-	<inceptionYear>2010</inceptionYear>
-	<developers>
-		<developer>
-			<id>imod</id>
-			<name>Dominik Bartholdi</name>
-			<email>-</email>
-		</developer>
-	</developers>
-	<repositories>
-		<repository>
-			<id>repo.jenkins-ci.org</id>
-			<url>http://repo.jenkins-ci.org/public/</url>
-		</repository>
-	</repositories>
-	<pluginRepositories>
-		<pluginRepository>
-			<id>repo.jenkins-ci.org</id>
-			<url>http://repo.jenkins-ci.org/public/</url>
-		</pluginRepository>
-	</pluginRepositories>
-	<properties>
-		<project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
-	</properties>
-	<build>
-		<pluginManagement>
-			<plugins>
-				<plugin>
-					<groupId>com.cloudbees</groupId>
-					<artifactId>maven-license-plugin</artifactId>
-					<version>1.7</version>
-				</plugin>
-				<plugin>
-					<groupId>org.kohsuke</groupId>
-					<artifactId>access-modifier-checker</artifactId>
-					<version>1.3</version>
-				</plugin>
-				<plugin>
-					<groupId>org.jvnet.localizer</groupId>
-					<artifactId>maven-localizer-plugin</artifactId>
-					<version>1.14</version>
-				</plugin>
-				<!--This plugin's configuration is used to store Eclipse m2e settings only. It has no influence on the Maven build itself. -->
-				<plugin>
-					<groupId>org.eclipse.m2e</groupId>
-					<artifactId>lifecycle-mapping</artifactId>
-					<version>1.0.0</version>
-					<configuration>
-						<lifecycleMappingMetadata>
-							<pluginExecutions>
-								<pluginExecution>
-									<pluginExecutionFilter>
-										<groupId>org.apache.maven.plugins</groupId>
-										<artifactId>maven-enforcer-plugin</artifactId>
-										<versionRange>[1.0,)</versionRange>
-										<goals>
-											<goal>display-info</goal>
-										</goals>
-									</pluginExecutionFilter>
-									<action>
-										<ignore />
-									</action>
-								</pluginExecution>
-								<pluginExecution>
-									<pluginExecutionFilter>
-										<groupId>org.codehaus.gmaven</groupId>
-										<artifactId>gmaven-plugin</artifactId>
-										<versionRange>[1.3,)</versionRange>
-										<goals>
-											<goal>generateTestStubs</goal>
-											<goal>testCompile</goal>
-										</goals>
-									</pluginExecutionFilter>
-									<action>
-										<ignore />
-									</action>
-								</pluginExecution>
-							</pluginExecutions>
-						</lifecycleMappingMetadata>
-					</configuration>
-				</plugin>
-			</plugins>
-		</pluginManagement>
-		<plugins>
-			<plugin>
-				<groupId>org.jenkins-ci.tools</groupId>
-				<artifactId>maven-hpi-plugin</artifactId>
-				<version>1.90</version>
-				<extensions>true</extensions>
-			</plugin>
-			<plugin>
-				<groupId>org.apache.maven.plugins</groupId>
-				<artifactId>maven-release-plugin</artifactId>
-				<version>2.0</version>
-				<configuration>
-					<goals>deploy</goals>
-				</configuration>
-				<dependencies>
-					<dependency>
-						<groupId>org.apache.maven.scm</groupId>
-						<artifactId>maven-scm-provider-gitexe</artifactId>
-						<version>1.3</version>
-					</dependency>
-				</dependencies>
-			</plugin>
-		</plugins>
-	</build>
-	<scm>
-		<connection>scm:git:git://github.com/jenkinsci/scriptler-plugin.git</connection>
-		<developerConnection>scm:git:ssh://git@github.com/jenkinsci/scriptler-plugin.git</developerConnection>
-		<url>https://github.com/jenkinsci/scriptler-plugin</url>
-	</scm>
-	<distributionManagement>
-		<repository>
-			<id>java.net-m2-repository</id>
-			<url>http://maven.jenkins-ci.org:8081/content/repositories/releases/</url>
-		</repository>
-		<snapshotRepository>
-			<!-- prevent accidental deployment of SNAPSHOTS to repository -->
-			<id>local.repository</id>
-			<url>file:/tmp/dummy-repo</url>
-		</snapshotRepository>
-	</distributionManagement>
-	<dependencies>
-		<dependency>
-			<groupId>org.jenkins-ci.plugins</groupId>
-			<artifactId>token-macro</artifactId>
-			<version>1.5.1</version>
-		</dependency>
+    <artifactId>scriptler</artifactId>
+    <name>Scriptler</name>
+    <version>2.6-NOEXCEPTION-SNAPSHOT</version>
+    <packaging>hpi</packaging>
+    <description>Scriptler allows you to store/edit/execute groovy scripts on any of the slaves/nodes... no need to copy paste groovy code anymore. Beside administer  your scripts, Scritpler also provides a way to share scripts between users via hosted script catalogs on the internet.</description>
+    <url>http://wiki.jenkins-ci.org/display/JENKINS/Scriptler+Plugin</url>
+    <inceptionYear>2010</inceptionYear>
+    <developers>
+        <developer>
+            <id>imod</id>
+            <name>Dominik Bartholdi</name>
+            <email>-</email>
+        </developer>
+    </developers>
+    <repositories>
+        <repository>
+            <id>repo.jenkins-ci.org</id>
+            <url>http://repo.jenkins-ci.org/public/</url>
+        </repository>
+    </repositories>
+    <pluginRepositories>
+        <pluginRepository>
+            <id>repo.jenkins-ci.org</id>
+            <url>http://repo.jenkins-ci.org/public/</url>
+        </pluginRepository>
+    </pluginRepositories>
+    <properties>
+        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
+    </properties>
+    <build>
+        <pluginManagement>
+            <plugins>
+                <plugin>
+                    <groupId>com.cloudbees</groupId>
+                    <artifactId>maven-license-plugin</artifactId>
+                    <version>1.7</version>
+                </plugin>
+                <plugin>
+                    <groupId>org.kohsuke</groupId>
+                    <artifactId>access-modifier-checker</artifactId>
+                    <version>1.3</version>
+                </plugin>
+                <plugin>
+                    <groupId>org.jvnet.localizer</groupId>
+                    <artifactId>maven-localizer-plugin</artifactId>
+                    <version>1.14</version>
+                </plugin>
+                <!--This plugin's configuration is used to store Eclipse m2e settings only. It has no influence on the Maven build itself. -->
+                <plugin>
+                    <groupId>org.eclipse.m2e</groupId>
+                    <artifactId>lifecycle-mapping</artifactId>
+                    <version>1.0.0</version>
+                    <configuration>
+                        <lifecycleMappingMetadata>
+                            <pluginExecutions>
+                                <pluginExecution>
+                                    <pluginExecutionFilter>
+                                        <groupId>org.apache.maven.plugins</groupId>
+                                        <artifactId>maven-enforcer-plugin</artifactId>
+                                        <versionRange>[1.0,)</versionRange>
+                                        <goals>
+                                            <goal>display-info</goal>
+                                        </goals>
+                                    </pluginExecutionFilter>
+                                    <action>
+                                        <ignore />
+                                    </action>
+                                </pluginExecution>
+                                <pluginExecution>
+                                    <pluginExecutionFilter>
+                                        <groupId>org.codehaus.gmaven</groupId>
+                                        <artifactId>gmaven-plugin</artifactId>
+                                        <versionRange>[1.3,)</versionRange>
+                                        <goals>
+                                            <goal>generateTestStubs</goal>
+                                            <goal>testCompile</goal>
+                                        </goals>
+                                    </pluginExecutionFilter>
+                                    <action>
+                                        <ignore />
+                                    </action>
+                                </pluginExecution>
+                            </pluginExecutions>
+                        </lifecycleMappingMetadata>
+                    </configuration>
+                </plugin>
+            </plugins>
+        </pluginManagement>
+        <plugins>
+            <plugin>
+                <groupId>org.jenkins-ci.tools</groupId>
+                <artifactId>maven-hpi-plugin</artifactId>
+                <version>1.90</version>
+                <extensions>true</extensions>
+            </plugin>
+            <plugin>
+                <groupId>org.apache.maven.plugins</groupId>
+                <artifactId>maven-release-plugin</artifactId>
+                <version>2.0</version>
+                <configuration>
+                    <goals>deploy</goals>
+                </configuration>
+                <dependencies>
+                    <dependency>
+                        <groupId>org.apache.maven.scm</groupId>
+                        <artifactId>maven-scm-provider-gitexe</artifactId>
+                        <version>1.3</version>
+                    </dependency>
+                </dependencies>
+            </plugin>
+        </plugins>
+    </build>
+    <scm>
+        <connection>scm:git:git://github.com/jenkinsci/scriptler-plugin.git</connection>
+        <developerConnection>scm:git:ssh://git@github.com/jenkinsci/scriptler-plugin.git</developerConnection>
+        <url>https://github.com/jenkinsci/scriptler-plugin</url>
+    </scm>
+    <distributionManagement>
+        <repository>
+            <id>java.net-m2-repository</id>
+            <url>http://maven.jenkins-ci.org:8081/content/repositories/releases/</url>
+        </repository>
+        <snapshotRepository>
+            <!-- prevent accidental deployment of SNAPSHOTS to repository -->
+            <id>local.repository</id>
+            <url>file:/tmp/dummy-repo</url>
+        </snapshotRepository>
+    </distributionManagement>
+    <dependencies>
+        <dependency>
+            <groupId>org.jenkins-ci.plugins</groupId>
+            <artifactId>token-macro</artifactId>
+            <version>1.6</version>
+        </dependency>
 
-		<dependency>
-			<groupId>org.jenkins-ci.modules</groupId>
-			<artifactId>sshd</artifactId>
-			<version>1.1</version>
-			<!-- <scope>provided</scope>this is in the core -->
-		</dependency>
+        <dependency>
+            <groupId>org.jenkins-ci.modules</groupId>
+            <artifactId>sshd</artifactId>
+            <version>1.1</version>
+            <!-- <scope>provided</scope>this is in the core -->
+        </dependency>
 
-		<dependency>
-			<groupId>org.jenkins-ci.plugins</groupId>
-			<artifactId>git-server</artifactId>
-			<version>1.1</version>
-		</dependency>
-	</dependencies>
+        <dependency>
+            <groupId>org.jenkins-ci.plugins</groupId>
+            <artifactId>git-server</artifactId>
+            <version>1.1</version>
+        </dependency>
+    </dependencies>
 </project>
diff --git a/src/main/java/org/jenkinsci/plugins/scriptler/builder/ScriptlerBuilder.java b/src/main/java/org/jenkinsci/plugins/scriptler/builder/ScriptlerBuilder.java
index a4b19c3..ff22e36 100644
--- a/src/main/java/org/jenkinsci/plugins/scriptler/builder/ScriptlerBuilder.java
+++ b/src/main/java/org/jenkinsci/plugins/scriptler/builder/ScriptlerBuilder.java
@@ -1,5 +1,5 @@
 /**
- * 
+ *
  */
 package org.jenkinsci.plugins.scriptler.builder;
 
@@ -46,7 +46,7 @@
 
 /**
  * @author Dominik Bartholdi (imod)
- * 
+ *
  */
 public class ScriptlerBuilder extends Builder implements Serializable {
     private static final long serialVersionUID = 1L;
@@ -101,12 +101,12 @@
                         final List<ParameterValue> jobParams = paramsAction.getParameters();
                         for (ParameterValue parameterValue : jobParams) {
                             // pass the params to the token expander in a way that these get expanded by environment variables (params are also environment variables)
-                            expandedParams.add(new Parameter(parameterValue.getName(), TokenMacro.expandAll(build, listener, "${" + parameterValue.getName() + "}")));
+                            expandedParams.add(new Parameter(parameterValue.getName(), TokenMacro.expandAll(build, listener, "${" + parameterValue.getName() + "}", false, null)));
                         }
                     }
                 }
                 for (Parameter parameter : parameters) {
-                    expandedParams.add(new Parameter(parameter.getName(), TokenMacro.expandAll(build, listener, parameter.getValue())));
+                    expandedParams.add(new Parameter(parameter.getName(), TokenMacro.expandAll(build, listener, parameter.getValue(), false, null)));
                 }
                 final Object output;
                 if (script.onlyMaster) {
@@ -226,7 +226,7 @@
 
         /**
          * gets the argument description to be displayed on the screen when selecting a config in the dropdown
-         * 
+         *
          * @param configId
          *            the config id to get the arguments description for
          * @return the description