diff --git a/test/src/main/java/org/jvnet/hudson/test/JenkinsRule.java b/test/src/main/java/org/jvnet/hudson/test/JenkinsRule.java
index 9d675be..b5c2b8e 100644
--- a/test/src/main/java/org/jvnet/hudson/test/JenkinsRule.java
+++ b/test/src/main/java/org/jvnet/hudson/test/JenkinsRule.java
@@ -219,6 +219,7 @@ import static org.junit.Assert.*;
 import static org.junit.matchers.JUnitMatchers.containsString;
 
 import org.junit.rules.TemporaryFolder;
+import org.kohsuke.stapler.StaplerProxy;
 
 /**
  * JUnit rule to allow test cases to fire up a Jenkins instance.
@@ -228,7 +229,7 @@ import org.junit.rules.TemporaryFolder;
  * @since 1.436
  */
 @SuppressWarnings({"deprecation","rawtypes"})
-public class JenkinsRule implements TestRule, MethodRule, RootAction {
+public class JenkinsRule implements TestRule, MethodRule, RootAction, StaplerProxy {
 
     private TestEnvironment env;
 
@@ -497,6 +498,14 @@ public class JenkinsRule implements TestRule, MethodRule, RootAction {
     @SuppressWarnings("serial")
     public static class BreakException extends Exception {}
 
+    @Override public Object getTarget() {
+        try {
+            return testDescription.getTestClass().newInstance();
+        } catch (Exception x) {
+            throw new AssertionError(x);
+        }
+    }
+
     public String getIconFileName() {
         return null;
     }
diff --git a/test/src/test/java/lib/form/RepeatableHeteroPropertyTest.java b/test/src/test/java/lib/form/RepeatableHeteroPropertyTest.java
new file mode 100644
index 0000000..42ced6f
--- /dev/null
+++ b/test/src/test/java/lib/form/RepeatableHeteroPropertyTest.java
@@ -0,0 +1,59 @@
+/*
+ * The MIT License
+ *
+ * Copyright 2013 Jesse Glick.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
+package lib.form;
+
+import com.gargoylesoftware.htmlunit.html.HtmlElement;
+import com.gargoylesoftware.htmlunit.html.HtmlForm;
+import com.gargoylesoftware.htmlunit.html.HtmlPage;
+import java.util.Collections;
+import java.util.List;
+import java.util.Set;
+import java.util.TreeSet;
+import static org.junit.Assert.assertEquals;
+import org.junit.Rule;
+import org.junit.Test;
+import org.jvnet.hudson.test.JenkinsRule;
+
+public class RepeatableHeteroPropertyTest {
+
+    @Rule public JenkinsRule j = new JenkinsRule();
+
+    public List<RepeatableTest.Fruit> getFruits() {
+        return Collections.emptyList();
+    }
+
+    @SuppressWarnings("StringEquality")
+    @Test public void filteredDescriptors() throws Exception {
+        HtmlPage page = j.createWebClient().goTo("self/filteredDescriptors");
+        HtmlForm form = page.getFormByName("config");
+        form.getButtonByCaption("Add").click();
+        Set<String> fruits = new TreeSet<String>();
+        for (HtmlElement a : form.getElementsByTagName("a")) {
+            fruits.add(a.asText());
+        }
+        assertEquals("[Apple, Banana]", fruits.toString());
+    }
+
+}
diff --git a/test/src/test/resources/lib/form/RepeatableHeteroPropertyTest/filteredDescriptors.jelly b/test/src/test/resources/lib/form/RepeatableHeteroPropertyTest/filteredDescriptors.jelly
new file mode 100644
index 0000000..74a8897
--- /dev/null
+++ b/test/src/test/resources/lib/form/RepeatableHeteroPropertyTest/filteredDescriptors.jelly
@@ -0,0 +1,16 @@
+<?jelly escape-by-default='true'?>
+<j:jelly xmlns:j="jelly:core" xmlns:l="/lib/layout" xmlns:f="/lib/form">
+    <l:layout title="RepeatableHeteroPropertyTest">
+        <l:main-panel>
+            <f:form method="post" name="config" action="irrelevant">
+                <j:set var="instance" value="${it}"/>
+                <j:set var="descriptor" value="${it.descriptor}"/>
+                <f:entry title="Fruits">
+                    <f:repeatableHeteroProperty field="fruits"/>
+                </f:entry>
+            </f:form>
+        </l:main-panel>
+    </l:layout>
+</j:jelly>
+    
+