<html><head><meta name="color-scheme" content="light dark"></head><body><pre style="word-wrap: break-word; white-space: pre-wrap;">diff --git a/pom.xml b/pom.xml
index 3836226..8648e7b 100644
--- a/pom.xml
+++ b/pom.xml
@@ -4,7 +4,7 @@
     &lt;parent&gt;
         &lt;groupId&gt;org.jenkins-ci.plugins&lt;/groupId&gt;
         &lt;artifactId&gt;plugin&lt;/artifactId&gt;
-        &lt;version&gt;1.596.1&lt;/version&gt;
+        &lt;version&gt;1.609.3&lt;/version&gt;
     &lt;/parent&gt;
     &lt;artifactId&gt;docker-workflow&lt;/artifactId&gt;
     &lt;version&gt;1.3-SNAPSHOT&lt;/version&gt;
@@ -28,7 +28,7 @@
   &lt;/scm&gt;
 
     &lt;properties&gt;
-        &lt;workflow.version&gt;1.7-alpha-1&lt;/workflow.version&gt;
+        &lt;workflow.version&gt;1.10&lt;/workflow.version&gt;
         &lt;maven-hpi-plugin.version&gt;1.112&lt;/maven-hpi-plugin.version&gt;
     &lt;/properties&gt;
     &lt;repositories&gt;
@@ -47,12 +47,12 @@
         &lt;dependency&gt;
             &lt;groupId&gt;org.jenkins-ci.plugins&lt;/groupId&gt;
             &lt;artifactId&gt;docker-commons&lt;/artifactId&gt;
-            &lt;version&gt;1.0&lt;/version&gt;
+            &lt;version&gt;1.2&lt;/version&gt;
         &lt;/dependency&gt;
         &lt;dependency&gt;
             &lt;groupId&gt;org.jenkins-ci.plugins&lt;/groupId&gt;
             &lt;artifactId&gt;script-security&lt;/artifactId&gt;
-            &lt;version&gt;1.14&lt;/version&gt;
+            &lt;version&gt;1.15&lt;/version&gt;
         &lt;/dependency&gt;
         &lt;dependency&gt;
             &lt;groupId&gt;org.jenkins-ci.plugins.workflow&lt;/groupId&gt;
diff --git a/src/test/java/org/jenkinsci/plugins/docker/workflow/DockerDSLTest.java b/src/test/java/org/jenkinsci/plugins/docker/workflow/DockerDSLTest.java
index 0665828..84eda31 100644
--- a/src/test/java/org/jenkinsci/plugins/docker/workflow/DockerDSLTest.java
+++ b/src/test/java/org/jenkinsci/plugins/docker/workflow/DockerDSLTest.java
@@ -45,8 +45,6 @@ import org.jenkinsci.plugins.docker.commons.fingerprint.DockerAncestorFingerprin
 import org.jenkinsci.plugins.docker.commons.fingerprint.DockerDescendantFingerprintFacet;
 import org.jenkinsci.plugins.docker.commons.fingerprint.DockerFingerprints;
 import org.jenkinsci.plugins.docker.commons.fingerprint.DockerRunFingerprintFacet;
-import org.jenkinsci.plugins.workflow.BuildWatcher;
-import org.jenkinsci.plugins.workflow.JenkinsRuleExt;
 import org.jenkinsci.plugins.workflow.cps.CpsFlowDefinition;
 import org.jenkinsci.plugins.workflow.job.WorkflowJob;
 import org.jenkinsci.plugins.workflow.job.WorkflowRun;
@@ -57,6 +55,7 @@ import org.junit.ClassRule;
 import org.junit.Rule;
 import org.junit.Test;
 import org.junit.runners.model.Statement;
+import org.jvnet.hudson.test.BuildWatcher;
 import org.jvnet.hudson.test.RestartableJenkinsRule;
 
 public class DockerDSLTest {
@@ -80,7 +79,7 @@ public class DockerDSLTest {
                 WorkflowRun b = p.getLastBuild();
                 assertEquals(Collections.&lt;String&gt;emptySet(), grep(b.getRootDir(), "org.jenkinsci.plugins.docker.workflow.Docker"));
                 SemaphoreStep.success("wait/1", null);
-                story.j.assertBuildStatusSuccess(JenkinsRuleExt.waitForCompletion(b));
+                story.j.assertBuildStatusSuccess(story.j.waitForCompletion(b));
             }
         });
     }
@@ -126,7 +125,7 @@ public class DockerDSLTest {
                 SemaphoreStep.success("wait/1", null);
                 WorkflowJob p = story.j.jenkins.getItemByFullName("p", WorkflowJob.class);
                 WorkflowRun b = p.getLastBuild();
-                story.j.assertLogContains("Require method GET POST OPTIONS", story.j.assertBuildStatusSuccess(JenkinsRuleExt.waitForCompletion(b)));
+                story.j.assertLogContains("Require method GET POST OPTIONS", story.j.assertBuildStatusSuccess(story.j.waitForCompletion(b)));
                 story.j.assertLogContains("the answer is 42", b);
                 DockerClient client = new DockerClient(new Launcher.LocalLauncher(StreamTaskListener.NULL), null, null);
                 String httpdIID = client.inspect(new EnvVars(), "httpd:2.4.12", ".Id");
@@ -163,7 +162,7 @@ public class DockerDSLTest {
             @Override public void evaluate() throws Throwable {
                 SemaphoreStep.success("wait/1", null);
                 WorkflowJob p = story.j.jenkins.getItemByFullName("p", WorkflowJob.class);
-                WorkflowRun b = story.j.assertBuildStatusSuccess(JenkinsRuleExt.waitForCompletion(p.getLastBuild()));
+                WorkflowRun b = story.j.assertBuildStatusSuccess(story.j.waitForCompletion(p.getLastBuild()));
                 story.j.assertLogContains("would be connecting to tcp://host:1234", b);
                 story.j.assertLogContains("image name is docker.my.com/whatever", b);
             }
@@ -210,7 +209,7 @@ public class DockerDSLTest {
                 SemaphoreStep.success("wait/1", null);
                 WorkflowJob p = story.j.jenkins.getItemByFullName("p", WorkflowJob.class);
                 WorkflowRun b = p.getLastBuild();
-                story.j.assertLogContains("Require method GET POST OPTIONS", story.j.assertBuildStatusSuccess(JenkinsRuleExt.waitForCompletion(b)));
+                story.j.assertLogContains("Require method GET POST OPTIONS", story.j.assertBuildStatusSuccess(story.j.waitForCompletion(b)));
                 story.j.assertLogContains("the answer is 42", b);
                 DockerClient client = new DockerClient(new Launcher.LocalLauncher(StreamTaskListener.NULL), null, null);
                 String httpdIID = client.inspect(new EnvVars(), "httpd:2.4.12", ".Id");
diff --git a/src/test/java/org/jenkinsci/plugins/docker/workflow/RegistryEndpointStepTest.java b/src/test/java/org/jenkinsci/plugins/docker/workflow/RegistryEndpointStepTest.java
index fec7d47..eda6e27 100644
--- a/src/test/java/org/jenkinsci/plugins/docker/workflow/RegistryEndpointStepTest.java
+++ b/src/test/java/org/jenkinsci/plugins/docker/workflow/RegistryEndpointStepTest.java
@@ -32,7 +32,6 @@ import java.util.Collections;
 import java.util.Map;
 import java.util.TreeMap;
 import org.jenkinsci.plugins.docker.commons.credentials.DockerRegistryEndpoint;
-import org.jenkinsci.plugins.workflow.BuildWatcher;
 import org.jenkinsci.plugins.workflow.steps.StepConfigTester;
 import org.jenkinsci.plugins.workflow.structs.DescribableHelper;
 import static org.junit.Assert.assertEquals;
@@ -41,6 +40,7 @@ import org.junit.ClassRule;
 import org.junit.Rule;
 import org.junit.Test;
 import org.junit.runners.model.Statement;
+import org.jvnet.hudson.test.BuildWatcher;
 import org.jvnet.hudson.test.RestartableJenkinsRule;
 
 public class RegistryEndpointStepTest {
diff --git a/src/test/java/org/jenkinsci/plugins/docker/workflow/ServerEndpointStepTest.java b/src/test/java/org/jenkinsci/plugins/docker/workflow/ServerEndpointStepTest.java
index 368df67..f7e4538 100644
--- a/src/test/java/org/jenkinsci/plugins/docker/workflow/ServerEndpointStepTest.java
+++ b/src/test/java/org/jenkinsci/plugins/docker/workflow/ServerEndpointStepTest.java
@@ -32,8 +32,6 @@ import java.util.Map;
 import java.util.TreeMap;
 import org.jenkinsci.plugins.docker.commons.credentials.DockerServerCredentials;
 import org.jenkinsci.plugins.docker.commons.credentials.DockerServerEndpoint;
-import org.jenkinsci.plugins.workflow.BuildWatcher;
-import org.jenkinsci.plugins.workflow.JenkinsRuleExt;
 import org.jenkinsci.plugins.workflow.cps.CpsFlowDefinition;
 import org.jenkinsci.plugins.workflow.job.WorkflowJob;
 import org.jenkinsci.plugins.workflow.job.WorkflowRun;
@@ -45,6 +43,7 @@ import static org.junit.Assert.*;
 import org.junit.ClassRule;
 import org.junit.Rule;
 import org.junit.runners.model.Statement;
+import org.jvnet.hudson.test.BuildWatcher;
 import org.jvnet.hudson.test.RestartableJenkinsRule;
 
 public class ServerEndpointStepTest {
@@ -93,7 +92,7 @@ public class ServerEndpointStepTest {
                 SemaphoreStep.success("wait/1", null);
                 WorkflowJob p = story.j.jenkins.getItemByFullName("p", WorkflowJob.class);
                 WorkflowRun b = p.getLastBuild();
-                story.j.assertLogContains("would be connecting to tcp://host:1234", story.j.assertBuildStatusSuccess(JenkinsRuleExt.waitForCompletion(b)));
+                story.j.assertLogContains("would be connecting to tcp://host:1234", story.j.assertBuildStatusSuccess(story.j.waitForCompletion(b)));
             }
         });
     }
diff --git a/src/test/java/org/jenkinsci/plugins/docker/workflow/WithContainerStepTest.java b/src/test/java/org/jenkinsci/plugins/docker/workflow/WithContainerStepTest.java
index 513bcb4..66324b5 100644
--- a/src/test/java/org/jenkinsci/plugins/docker/workflow/WithContainerStepTest.java
+++ b/src/test/java/org/jenkinsci/plugins/docker/workflow/WithContainerStepTest.java
@@ -27,8 +27,6 @@ import hudson.model.Result;
 import hudson.tools.ToolProperty;
 import java.util.Collections;
 import org.jenkinsci.plugins.docker.commons.tools.DockerTool;
-import org.jenkinsci.plugins.workflow.BuildWatcher;
-import org.jenkinsci.plugins.workflow.JenkinsRuleExt;
 import org.jenkinsci.plugins.workflow.cps.CpsFlowDefinition;
 import org.jenkinsci.plugins.workflow.job.WorkflowJob;
 import org.jenkinsci.plugins.workflow.job.WorkflowRun;
@@ -38,6 +36,7 @@ import org.junit.ClassRule;
 import org.junit.Test;
 import org.junit.Rule;
 import org.junit.runners.model.Statement;
+import org.jvnet.hudson.test.BuildWatcher;
 import org.jvnet.hudson.test.RestartableJenkinsRule;
 
 public class WithContainerStepTest {
@@ -88,9 +87,9 @@ public class WithContainerStepTest {
                     "  }\n" +
                     "}", true));
                 WorkflowRun b = p.scheduleBuild2(0).waitForStart();
-                JenkinsRuleExt.waitForMessage("sleeping now", b);
+                story.j.waitForMessage("sleeping now", b);
                 b.doStop();
-                story.j.assertBuildStatus(Result.ABORTED, JenkinsRuleExt.waitForCompletion(b));
+                story.j.assertBuildStatus(Result.ABORTED, story.j.waitForCompletion(b));
                 story.j.assertLogContains("script returned exit code 99", b);
             }
         });
@@ -117,7 +116,7 @@ public class WithContainerStepTest {
                 SemaphoreStep.success("wait/1", null);
                 WorkflowJob p = story.j.jenkins.getItemByFullName("p", WorkflowJob.class);
                 WorkflowRun b = p.getLastBuild();
-                story.j.assertLogContains("Require method GET POST OPTIONS", story.j.assertBuildStatusSuccess(JenkinsRuleExt.waitForCompletion(b)));
+                story.j.assertLogContains("Require method GET POST OPTIONS", story.j.assertBuildStatusSuccess(story.j.waitForCompletion(b)));
             }
         });
     }
</pre></body></html>