--- config.xml	2020-06-10 14:37:06.595465280 -0400
+++ config.xml.garbled	2020-06-10 15:14:07.039142272 -0400
@@ -4,7 +4,7 @@
     <string>user_junior_process.node_monitors.MonitorMarkedNodeOffline</string>
     <string>OldData</string>
   </disabledAdministrativeMonitors>
-  <version>2.238</version>
+  <version>2.240</version>
   <installStateName>RUNNING</installStateName>
   <numExecutors>1</numExecutors>
   <mode>EXCLUSIVE</mode>
@@ -196,122 +196,6 @@
     </listView>
     <listView>
       <owner class="user_junior_process" reference="../../.."/>
-      <name>view_harmful_navy</name>
-      <filterExecutors>true</filterExecutors>
-      <filterQueue>false</filterQueue>
-      <properties class="user_junior_process.model.View$PropertyList"/>
-      <jobNames>
-        <comparator class="user_junior_process.util.CaseInsensitiveComparator" reference="../../../listView/jobNames/comparator"/>
-        <string>item_right_foreigner</string>
-        <string>item_unemployed_kite</string>
-        <string>item_empty_relation</string>
-        <string>item_inadequate_street</string>
-        <string>item_uniform_declaration</string>
-        <string>item_safe_string</string>
-        <string>item_plain_leaflet</string>
-        <string>item_spontaneous_park</string>
-        <string>item_poor_detail</string>
-        <string>item_statistical_future</string>
-        <string>item_possible_access</string>
-        <string>item_still_catalogue</string>
-        <string>item_low_garlic</string>
-        <string>item_presidential_length</string>
-        <string>item_tight_taxpayer</string>
-        <string>item_awake_agency</string>
-        <string>item_persistent_clerk</string>
-        <string>item_sophisticated_drug</string>
-        <string>item_fine_plate</string>
-        <string>item_legal_school</string>
-        <string>item_aesthetic_coincidence</string>
-        <string>item_funny_headquarters</string>
-        <string>item_privileged_pollution</string>
-        <string>item_marine_elbow</string>
-        <string>item_progressive_heaven</string>
-        <string>item_holy_prayer</string>
-        <string>item_multiple_set</string>
-      </jobNames>
-      <jobFilters/>
-      <columns>
-        <user_junior_process.views.StatusColumn/>
-        <user_junior_process.views.WeatherColumn/>
-        <user_junior_process.views.JobColumn/>
-        <user_junior_process.views.LastSuccessColumn/>
-        <user_junior_process.views.LastFailureColumn/>
-        <user_junior_process.views.LastDurationColumn/>
-        <user_junior_process.views.BuildButtonColumn/>
-      </columns>
-      <recurse>false</recurse>
-      <statusFilter>true</statusFilter>
-    </listView>
-    <listView>
-      <owner class="user_junior_process" reference="../../.."/>
-      <name>view_dependent_publisher</name>
-      <filterExecutors>false</filterExecutors>
-      <filterQueue>false</filterQueue>
-      <properties class="user_junior_process.model.View$PropertyList"/>
-      <jobNames>
-        <comparator class="user_junior_process.util.CaseInsensitiveComparator" reference="../../../listView/jobNames/comparator"/>
-        <string>item_true_wilderness</string>
-        <string>item_noisy_debt</string>
-        <string>item_cautious_calculation</string>
-        <string>item_senior_fox</string>
-        <string>item_acceptable_prize</string>
-        <string>item_commercial_suite</string>
-        <string>item_passionate_dependence</string>
-        <string>item_warm_law</string>
-        <string>item_comprehensive_fuel</string>
-        <string>item_personal_resort</string>
-        <string>item_sound_sunshine</string>
-        <string>item_conservative_cart</string>
-        <string>item_plain_leaflet</string>
-        <string>item_young_rest</string>
-        <string>item_acceptable_diagnosis</string>
-        <string>item_crude_cause</string>
-        <string>item_low_garlic</string>
-        <string>item_presidential_length</string>
-        <string>item_hungry_rotation</string>
-        <string>item_nervous_television</string>
-        <string>item_restless_air</string>
-        <string>item_ultimate_check</string>
-        <string>item_elegant_grace</string>
-        <string>item_opposed_piece</string>
-        <string>item_serious_mail</string>
-        <string>item_valuable_pile</string>
-        <string>item_other_circle</string>
-        <string>item_viable_growth</string>
-        <string>item_internal_sandal</string>
-        <string>item_single_anniversary</string>
-        <string>item_comfortable_dream</string>
-        <string>item_part-time_pity</string>
-        <string>item_related_flavour</string>
-        <string>item_military_cucumber</string>
-        <string>item_academic_poetry</string>
-        <string>item_free_toe</string>
-        <string>item_stubborn_armchair</string>
-        <string>item_dangerous_article</string>
-        <string>item_amber_porter</string>
-        <string>item_thick_merchant</string>
-        <string>item_assertive_powder</string>
-        <string>item_relative_transaction</string>
-        <string>item_tough_attitude</string>
-        <string>item_trivial_shadow</string>
-        <string>item_bare_trap</string>
-      </jobNames>
-      <jobFilters/>
-      <columns>
-        <user_junior_process.views.StatusColumn/>
-        <user_junior_process.views.WeatherColumn/>
-        <user_junior_process.views.JobColumn/>
-        <user_junior_process.views.LastSuccessColumn/>
-        <user_junior_process.views.LastFailureColumn/>
-        <user_junior_process.views.LastDurationColumn/>
-        <user_junior_process.views.BuildButtonColumn/>
-      </columns>
-      <recurse>false</recurse>
-      <statusFilter>true</statusFilter>
-    </listView>
-    <listView>
-      <owner class="user_junior_process" reference="../../.."/>
       <name>view_glorious_fair</name>
       <filterExecutors>false</filterExecutors>
       <filterQueue>false</filterQueue>
@@ -361,7 +245,7 @@
         <string>item_healthy_river</string>
         <string>item_dry_character</string>
         <string>item_ordinary_grimace</string>
-        <string>MainSplitJava7</string>
+        <string>view_dependent_publisherSplitJava7</string>
         <string>item_late_appeal</string>
         <string>item_physical_tile</string>
         <string>item_curious_effect</string>
@@ -422,7 +306,7 @@
       <properties class="user_junior_process.model.View$PropertyList"/>
       <jobNames>
         <comparator class="user_junior_process.util.CaseInsensitiveComparator" reference="../../../listView/jobNames/comparator"/>
-        <string>YESABBranchExdocs</string>
+        <string>view_historical_blackmailExdocs</string>
         <string>item_unfair_baby</string>
         <string>item_broken_concept</string>
         <string>item_enjoyable_era</string>
@@ -555,58 +439,6 @@
     </listView>
     <listView>
       <owner class="user_junior_process" reference="../../.."/>
-      <name>view_deep_vehicle</name>
-      <description>All the things view_deep_vehicle</description>
-      <filterExecutors>false</filterExecutors>
-      <filterQueue>false</filterQueue>
-      <properties class="user_junior_process.model.View$PropertyList"/>
-      <jobNames>
-        <comparator class="user_junior_process.util.CaseInsensitiveComparator" reference="../../../listView/jobNames/comparator"/>
-        <string>item_cautious_calculation</string>
-        <string>item_federal_lead</string>
-        <string>item_personal_resort</string>
-        <string>item_sound_sunshine</string>
-        <string>item_conservative_cart</string>
-        <string>item_plain_leaflet</string>
-        <string>item_spontaneous_park</string>
-        <string>item_crude_cause</string>
-        <string>item_low_garlic</string>
-        <string>item_presidential_length</string>
-        <string>item_hungry_rotation</string>
-        <string>item_nervous_television</string>
-        <string>item_restless_air</string>
-        <string>item_opposed_piece</string>
-        <string>item_serious_mail</string>
-        <string>item_valuable_pile</string>
-        <string>item_viable_growth</string>
-        <string>item_comfortable_dream</string>
-        <string>item_part-time_pity</string>
-        <string>item_persistent_clerk</string>
-        <string>item_sophisticated_drug</string>
-        <string>item_specified_apple</string>
-        <string>item_academic_poetry</string>
-        <string>item_free_toe</string>
-        <string>item_available_hip</string>
-        <string>item_relative_transaction</string>
-        <string>item_tough_attitude</string>
-        <string>item_trivial_shadow</string>
-        <string>item_bare_trap</string>
-      </jobNames>
-      <jobFilters/>
-      <columns>
-        <user_junior_process.views.StatusColumn/>
-        <user_junior_process.views.WeatherColumn/>
-        <user_junior_process.views.JobColumn/>
-        <user_junior_process.views.LastSuccessColumn/>
-        <user_junior_process.views.LastFailureColumn/>
-        <user_junior_process.views.LastDurationColumn/>
-        <user_junior_process.views.BuildButtonColumn/>
-      </columns>
-      <recurse>false</recurse>
-      <statusFilter>true</statusFilter>
-    </listView>
-    <listView>
-      <owner class="user_junior_process" reference="../../.."/>
       <name>view_gregarious_sock</name>
       <filterExecutors>false</filterExecutors>
       <filterQueue>false</filterQueue>
@@ -654,86 +486,6 @@
     </listView>
     <listView>
       <owner class="user_junior_process" reference="../../.."/>
-      <name>view_miserable_punch</name>
-      <filterExecutors>false</filterExecutors>
-      <filterQueue>false</filterQueue>
-      <properties class="user_junior_process.model.View$PropertyList"/>
-      <jobNames>
-        <comparator class="user_junior_process.util.CaseInsensitiveComparator" reference="../../../listView/jobNames/comparator"/>
-        <string>item_restricted_organ</string>
-        <string>item_useful_remark</string>
-        <string>item_influential_calorie</string>
-        <string>item_chronic_pack</string>
-        <string>item_joint_car</string>
-        <string>item_competent_paper</string>
-        <string>item_long_pass</string>
-        <string>item_modern_target</string>
-        <string>item_real_advocate</string>
-        <string>item_astonishing_discourse</string>
-        <string>item_high_lip</string>
-        <string>item_rich_row</string>
-        <string>item_bloody_alarm</string>
-        <string>item_unfortunate_philosopher</string>
-        <string>item_enthusiastic_term</string>
-        <string>item_sad_doll</string>
-        <string>item_careful_lump</string>
-        <string>item_scientific_amateur</string>
-        <string>item_even_gravity</string>
-        <string>item_infinite_machinery</string>
-        <string>item_vacant_theatre</string>
-        <string>item_exclusive_chorus</string>
-        <string>item_formal_coach</string>
-        <string>item_positive_harbour</string>
-        <string>item_lonely_area</string>
-        <string>item_subsequent_secretion</string>
-        <string>item_human_competition</string>
-      </jobNames>
-      <jobFilters/>
-      <columns>
-        <user_junior_process.views.StatusColumn/>
-        <user_junior_process.views.WeatherColumn/>
-        <user_junior_process.views.JobColumn/>
-        <user_junior_process.views.LastSuccessColumn/>
-        <user_junior_process.views.LastFailureColumn/>
-        <user_junior_process.views.LastDurationColumn/>
-        <user_junior_process.views.BuildButtonColumn/>
-      </columns>
-      <includeRegex>^(.*)view_miserable_punch(.*)</includeRegex>
-      <recurse>false</recurse>
-      <statusFilter>true</statusFilter>
-    </listView>
-    <listView>
-      <owner class="user_junior_process" reference="../../.."/>
-      <name>view_dominant_view</name>
-      <filterExecutors>false</filterExecutors>
-      <filterQueue>false</filterQueue>
-      <properties class="user_junior_process.model.View$PropertyList"/>
-      <jobNames>
-        <comparator class="user_junior_process.util.CaseInsensitiveComparator" reference="../../../listView/jobNames/comparator"/>
-        <string>item_competent_paper</string>
-        <string>item_distinct_glove</string>
-        <string>item_monthly_pencil</string>
-        <string>item_regional_rock</string>
-        <string>item_jealous_manual</string>
-        <string>item_sticky_master</string>
-        <string>item_dynamic_engagement</string>
-        <string>item_human_competition</string>
-      </jobNames>
-      <jobFilters/>
-      <columns>
-        <user_junior_process.views.StatusColumn/>
-        <user_junior_process.views.WeatherColumn/>
-        <user_junior_process.views.JobColumn/>
-        <user_junior_process.views.LastSuccessColumn/>
-        <user_junior_process.views.LastFailureColumn/>
-        <user_junior_process.views.LastDurationColumn/>
-        <user_junior_process.views.BuildButtonColumn/>
-      </columns>
-      <recurse>false</recurse>
-      <statusFilter>true</statusFilter>
-    </listView>
-    <listView>
-      <owner class="user_junior_process" reference="../../.."/>
       <name>view_surprising_psychology</name>
       <description>Jobs that perform deployment to specific systems</description>
       <filterExecutors>false</filterExecutors>
@@ -765,7 +517,7 @@
       <jobNames>
         <comparator class="user_junior_process.util.CaseInsensitiveComparator" reference="../../../listView/jobNames/comparator"/>
         <string>item_inner_princess</string>
-        <string>Testing</string>
+        <string>view_reasonable_neglecting</string>
       </jobNames>
       <jobFilters/>
       <columns>
@@ -806,151 +558,6 @@
       </columns>
       <recurse>true</recurse>
     </listView>
-    <com.smartcodeltd.jenkinsci.plugins.buildmonitor.BuildMonitorView plugin="build-monitor-plugin@1.12+build.201809061734">
-      <owner class="user_junior_process" reference="../../.."/>
-      <name>view_commercial_parliament</name>
-      <filterExecutors>false</filterExecutors>
-      <filterQueue>false</filterQueue>
-      <properties class="user_junior_process.model.View$PropertyList"/>
-      <jobNames>
-        <comparator class="user_junior_process.util.CaseInsensitiveComparator" reference="../../../listView/jobNames/comparator"/>
-        <string>item_ignorant_fire</string>
-        <string>item_bureaucratic_format</string>
-        <string>item_brave_dentist</string>
-        <string>item_critical_matter</string>
-        <string>item_aesthetic_stroke</string>
-        <string>item_dramatic_method</string>
-      </jobNames>
-      <jobFilters/>
-      <columns/>
-      <includeRegex>item_passionate_dependence.*master</includeRegex>
-      <recurse>true</recurse>
-      <statusFilter>true</statusFilter>
-      <title>System Health</title>
-      <config>
-        <displayCommitters>true</displayCommitters>
-        <buildFailureAnalyzerDisplayedField>Name</buildFailureAnalyzerDisplayedField>
-        <order class="com.smartcodeltd.jenkinsci.plugins.buildmonitor.order.ByName"/>
-      </config>
-    </com.smartcodeltd.jenkinsci.plugins.buildmonitor.BuildMonitorView>
-    <com.smartcodeltd.jenkinsci.plugins.buildmonitor.BuildMonitorView plugin="build-monitor-plugin@1.12+build.201809061734">
-      <owner class="user_junior_process" reference="../../.."/>
-      <name>view_arrogant_farm</name>
-      <filterExecutors>false</filterExecutors>
-      <filterQueue>false</filterQueue>
-      <properties class="user_junior_process.model.View$PropertyList"/>
-      <jobNames>
-        <comparator class="user_junior_process.util.CaseInsensitiveComparator" reference="../../../listView/jobNames/comparator"/>
-        <string>item_restricted_organ</string>
-        <string>item_useful_remark</string>
-        <string>item_influential_calorie</string>
-        <string>item_chronic_pack</string>
-        <string>item_joint_car</string>
-        <string>item_competent_paper</string>
-        <string>item_long_pass</string>
-        <string>item_modern_target</string>
-        <string>item_real_advocate</string>
-        <string>item_astonishing_discourse</string>
-        <string>item_high_lip</string>
-        <string>item_rich_row</string>
-        <string>item_bloody_alarm</string>
-        <string>item_unfortunate_philosopher</string>
-        <string>item_enthusiastic_term</string>
-        <string>item_sad_doll</string>
-        <string>item_careful_lump</string>
-        <string>item_scientific_amateur</string>
-        <string>item_even_gravity</string>
-        <string>item_infinite_machinery</string>
-        <string>item_vacant_theatre</string>
-        <string>item_exclusive_chorus</string>
-        <string>item_formal_coach</string>
-        <string>item_positive_harbour</string>
-        <string>item_lonely_area</string>
-        <string>item_subsequent_secretion</string>
-        <string>item_human_competition</string>
-      </jobNames>
-      <jobFilters/>
-      <columns/>
-      <includeRegex>^(.*)view_miserable_punch(.*)</includeRegex>
-      <recurse>false</recurse>
-      <statusFilter>true</statusFilter>
-      <title>view_arrogant_farm</title>
-      <config>
-        <displayCommitters>false</displayCommitters>
-        <buildFailureAnalyzerDisplayedField>Name</buildFailureAnalyzerDisplayedField>
-        <order class="com.smartcodeltd.jenkinsci.plugins.buildmonitor.order.ByName"/>
-      </config>
-    </com.smartcodeltd.jenkinsci.plugins.buildmonitor.BuildMonitorView>
-    <com.smartcodeltd.jenkinsci.plugins.buildmonitor.BuildMonitorView plugin="build-monitor-plugin@1.12+build.201809061734">
-      <owner class="user_junior_process" reference="../../.."/>
-      <name>view_mild_venture</name>
-      <filterExecutors>false</filterExecutors>
-      <filterQueue>false</filterQueue>
-      <properties class="user_junior_process.model.View$PropertyList"/>
-      <jobNames>
-        <comparator class="user_junior_process.util.CaseInsensitiveComparator" reference="../../../listView/jobNames/comparator"/>
-        <string>item_true_wilderness</string>
-        <string>item_noisy_debt</string>
-        <string>item_safe_string</string>
-        <string>item_cautious_calculation</string>
-        <string>item_warm_law</string>
-        <string>item_personal_resort</string>
-        <string>item_sound_sunshine</string>
-        <string>item_conservative_cart</string>
-        <string>item_acceptable_diagnosis</string>
-        <string>item_crude_cause</string>
-        <string>item_hungry_rotation</string>
-        <string>item_nervous_television</string>
-        <string>item_restless_air</string>
-        <string>item_opposed_piece</string>
-        <string>item_other_circle</string>
-        <string>item_viable_growth</string>
-        <string>item_internal_sandal</string>
-        <string>item_comfortable_dream</string>
-        <string>item_sophisticated_drug</string>
-        <string>item_specified_apple</string>
-        <string>item_free_toe</string>
-        <string>item_funny_headquarters</string>
-        <string>item_privileged_pollution</string>
-        <string>item_amber_porter</string>
-        <string>item_thick_merchant</string>
-        <string>item_assertive_powder</string>
-        <string>item_available_hip</string>
-        <string>item_tough_attitude</string>
-        <string>item_bare_trap</string>
-      </jobNames>
-      <jobFilters/>
-      <columns/>
-      <recurse>true</recurse>
-      <statusFilter>true</statusFilter>
-      <title>view_deep_vehicle and view_helpful_father System Health</title>
-      <config>
-        <displayCommitters>false</displayCommitters>
-        <buildFailureAnalyzerDisplayedField>Name</buildFailureAnalyzerDisplayedField>
-        <order class="com.smartcodeltd.jenkinsci.plugins.buildmonitor.order.ByName"/>
-      </config>
-    </com.smartcodeltd.jenkinsci.plugins.buildmonitor.BuildMonitorView>
-    <com.smartcodeltd.jenkinsci.plugins.buildmonitor.BuildMonitorView plugin="build-monitor-plugin@1.12+build.201809061734">
-      <owner class="user_junior_process" reference="../../.."/>
-      <name>view_racial_biography</name>
-      <filterExecutors>false</filterExecutors>
-      <filterQueue>false</filterQueue>
-      <properties class="user_junior_process.model.View$PropertyList"/>
-      <jobNames>
-        <comparator class="user_junior_process.util.CaseInsensitiveComparator" reference="../../../listView/jobNames/comparator"/>
-      </jobNames>
-      <jobFilters/>
-      <columns/>
-      <includeRegex>(?!Thang.*).*(view_surprising_psychology|Rollbackx).*|item_dangerous_article</includeRegex>
-      <recurse>false</recurse>
-      <statusFilter>true</statusFilter>
-      <title>view_racial_biography</title>
-      <config>
-        <displayCommitters>false</displayCommitters>
-        <buildFailureAnalyzerDisplayedField>Name</buildFailureAnalyzerDisplayedField>
-        <order class="com.smartcodeltd.jenkinsci.plugins.buildmonitor.order.ByName"/>
-      </config>
-    </com.smartcodeltd.jenkinsci.plugins.buildmonitor.BuildMonitorView>
   </views>
   <primaryView>view_dependent_publisher</primaryView>
   <slaveAgentPort>-1</slaveAgentPort>
@@ -974,4 +581,4 @@
       </envVars>
     </user_junior_process.slaves.EnvironmentVariablesNodeProperty>
   </globalNodeProperties>
-</user_junior_process>
+</user_junior_process>
\ No newline at end of file